(***************************************************************************)
(* Benchmark name: Memoir-T. Proofs by FOL and SMT backends.               *)
(***************************************************************************)

---- MODULE MemoirLL1TypeSafetyWithSMT----

EXTENDS TLAPS, MemoirLL1TypeLemmas, Integers

(***************************************************************************)
(* Proof size: 1 (only inductive step <1>1)                                *)
(* Original proof size: 424                                                *)
(* CVC4 time: timeout                                                      *)
(* Z3 time: 1.99s                                                          *)
(* E time: timeout                                                         *)
(* SPASS time: 39.72s                                                      *)
(***************************************************************************)

THEOREM LL1TypeSafe == LL1Spec => []LL1TypeInvariant \*`^\label{THEOREM-LL1TypeSafe}^'
  <1>1. LL1Init => LL1TypeInvariant
    BY ConstantsTypeSafe, SymmetricEncryptionTypeSafe, HashTypeSafe,
       BaseHashValueTypeSafe, GenerateMACTypeSafe, SMT
    DEFS LL1Init, HashDomain, LL1TypeInvariant,
       LL1UntrustedStorageType, LL1TrustedStorageType, HashDomain
  <1>2. LL1TypeInvariant /\ [LL1Next]_LL1Vars => LL1TypeInvariant'
    BY SymmetricDecryptionTypeSafe, SymmetricEncryptionTypeSafe,
       GenerateMACTypeSafe, ServiceTypeSafe, HashTypeSafe,
       Z3           \** time: 1.99s
\*       SpassT(60)    \**  time: 39.72s
    DEFS LL1TypeInvariant, LL1Next, LL1Vars, LL1UntrustedStorageType, LL1TrustedStorageType,
      LL1MakeInputAvailable, LL1PerformOperation, LL1SubtypeImplication, ServiceResultType, HashDomain,
      LL1RepeatOperation, LL1Restart, LL1ReadDisk, LL1WriteDisk, LL1CorruptRAM, LL1RestrictedCorruption
  <1>3. QED

(***************************************************************************)
(* Proof size: 12 (only inductive step <1>1)                               *)
(* CVC4 time: 3.11                                                         *)
(* Z3 time: 3.21                                                           *)
(* E time: timeout                                                         *)
(* SPASS time: 9.43                                                        *)
(***************************************************************************)

THEOREM LL1TypeSafe_1 == LL1Spec => []LL1TypeInvariant \*`^\label{THEOREM-LL1TypeSafe}^'
  <1>1. LL1Init => LL1TypeInvariant
    BY ConstantsTypeSafe, SymmetricEncryptionTypeSafe, HashTypeSafe,
       BaseHashValueTypeSafe, GenerateMACTypeSafe
    DEFS LL1Init, HashDomain, LL1TypeInvariant,
       LL1UntrustedStorageType, LL1TrustedStorageType, HashDomain
  <1>2. LL1TypeInvariant /\ [LL1Next]_LL1Vars => LL1TypeInvariant'
    <2>1. HAVE LL1TypeInvariant /\ [LL1Next]_LL1Vars
    <2>2. CASE UNCHANGED LL1Vars
      BY <2>1, <2>2, SMT DEF LL1TypeInvariant, LL1Vars
    <2>3. CASE LL1Next
      <3>1. CASE LL1MakeInputAvailable
          BY <2>1, <3>1, SMT DEF LL1MakeInputAvailable, LL1TypeInvariant
      <3>2. CASE LL1PerformOperation
        <4>1. PICK input \in LL1AvailableInputs: LL1PerformOperation!(input)!1!1
          BY <3>2, SMT DEF LL1PerformOperation
        <4>9. QED
          BY <2>1, <3>2, <4>1,
             LL1PerformOperationDefsTypeSafeLemma, LL1SubtypeImplicationLemma, SMT
          DEF LL1TypeInvariant,
              LL1TrustedStorageType,
              LL1PerformOperation,
              LL1SubtypeImplication,
              LL1UntrustedStorageType
      <3>3. CASE LL1RepeatOperation
          BY <2>1, <3>3,
            LL1SubtypeImplicationLemma, LL1RepeatOperationDefsTypeSafeLemma, SMT
          DEF LL1TypeInvariant, LL1SubtypeImplication, LL1UntrustedStorageType, LL1RepeatOperation
      <3>4. CASE LL1Restart
        BY <2>1, <3>4, SMT DEF LL1Restart, LL1TypeInvariant
      <3>5. CASE LL1ReadDisk
        BY <2>1, <3>5, SMT DEF LL1ReadDisk, LL1TypeInvariant
      <3>6. CASE LL1WriteDisk
        BY <2>1, <3>6, SMT DEF LL1WriteDisk, LL1TypeInvariant
      <3>7. CASE LL1CorruptRAM
        BY <2>1, <3>7, SMT DEF LL1CorruptRAM, LL1TypeInvariant
      <3>8. CASE LL1RestrictedCorruption
        BY <2>1, <3>8,LL1SubtypeImplicationLemma, SMT
        DEF LL1RestrictedCorruption, LL1TypeInvariant, LL1SubtypeImplication, LL1TrustedStorageType
      <3>9. QED
        BY <2>3, <3>1, <3>2, <3>3, <3>4, <3>5, <3>6, <3>7, <3>8, SMT DEF LL1Next
    <2>4. QED
      BY <2>1, <2>2, <2>3, SMT
  <1>3. QED

====
